#!/usr/bin/perl
# search.cgi
# Find .htaccess files under some directory

require './htaccess-lib.pl';
&foreign_require($apachemod, "apache-lib.pl");

&ReadParse();
&error_setup($text{'search_err'});
$in{'search'} =~ /^\// && $in{'search'} !~ /\.\./ ||
	&error($text{'search_edir'});
&can_access_dir($in{'search'}) || &error($text{'search_ecannot'});

$| = 1;
$theme_no_table++;
&header($text{'search_title'}, "");
print "<hr>\n";

@dirs = &list_directories();
%got = map { $_->[0], 1 } @dirs;
print "<b>",&text('search_doing', "<tt>$in{'search'}</tt>"),"</b><p>\n";

# Use the find command
&switch_user();
open(FIND, "find ".quotemeta($in{'search'})." -name ".
	   quotemeta($config{'htaccess'})." -print 2>/dev/null |");
while($f = <FIND>) {
	chop($f);
	if ($got{$f}) {
		print &text('search_already', "<tt>$f</tt>"),"<br>\n";
		}
	elsif (!open(TEST, $f)) {
		print &text('search_open', "<tt>$f</tt>", $!),"<br>\n";
		}
	else {
		$conf = &foreign_call($apachemod, "get_htaccess_config", $f);
		$currfile = &foreign_call($apachemod, "find_directive",
					  "AuthUserFile", $conf, 1);
		if ($currfile) {
			print &text('search_found', "<tt>$f</tt>",
				    "<tt>$currfile</tt>"),"<br>\n";
			push(@dirs, [ $f, $currfile ]);
			}
		else {
			print &text('search_noprot', "<tt>$f</tt>"),"<br>\n";
			}
		}
	}
close(FIND);
print "<p><b>$text{'search_done'}</b><p>\n";
&switch_back();

&lock_file($directories_file);
&save_directories(\@dirs);
&unlock_file($directories_file);
&webmin_log("search", $in{'search'});

print "<hr>\n";
&footer("", $text{'index_return'});


