#!/usr/bin/perl
# Display a form for replying to or composing an email

require './mailbox-lib.pl';

&ReadParse();
$module_index_link = "/$module_name/index.cgi?folder=$in{'folder'}";
@folders = &list_folders();
$folder = $folders[$in{'folder'}];
if ($in{'new'}) {
	# Composing a new email
	&header($text{'compose_title'}, "");
	$sig = &get_signature();
	$quote = "\n\n$sig" if ($sig);
	}
else {
	# Replying or forwarding
	if ($in{'mailforward'} ne '') {
		# Replying to multiple
		@mailforward = split(/\0/, $in{'mailforward'});
		@mails = &mailbox_list_mails(
			     $mailforward[0], $mailforward[@mailforward-1],
			     $folder);
		$mail = $mails[$mailforward[0]];
		}
	else {
		# Replying to one
		@mails = &mailbox_list_mails($in{'idx'}, $in{'idx'},
					     $folder);
		$mail = $mails[$in{'idx'}];
		&decode_and_sub();
		}

	if ($in{'delete'}) {
		# Just delete the email
		if (!$in{'confirm'} && &need_delete_warn($folder)) {
			# Need to ask for confirmation before deleting
			&header($text{'confirm_title'}, "");
			print &check_clicks_function();
			print "<hr>\n";

			print "<form action=reply_mail.cgi>\n";
			foreach $i (keys %in) {
				foreach $v (split(/\0/, $in{$i})) {
					print "<input type=hidden name=$i ",
					      "value='",&html_escape($v),"'>\n";
					}
				}
			print "<center><b>$text{'confirm_warn3'}<br>\n";
			if ($userconfig{'delete_warn'} ne 'y') {
				print "$text{'confirm_warn2'}<p>\n"
				}
			else {
				print "$text{'confirm_warn4'}<p>\n"
				}
			print "</b><p><input type=submit name=confirm ",
			      "value='$text{'confirm_ok'}' ",
			      "onClick='return check_clicks(form)'></center></form>\n";
			
			print "<hr>\n";
			&footer("view_mail.cgi?idx=$in{'idx'}&folder=$in{'folder'}",
				$text{'view_return'},
				"index.cgi?folder=$in{'folder'}",
				$text{'index'});
			exit;
			}
		&lock_folder($folder);
		&mailbox_delete_mail($folder, $mail);
		&unlock_folder($folder);
		&pop3_logout_all();
		&redirect("index.cgi?folder=$in{'folder'}");
		exit;
		}
	elsif ($in{'print'}) {
		# Extract the mail body
		&decode_and_sub();
		($textbody, $htmlbody, $body) = &find_body($mail);

		# Output HTML header
		&PrintHeader();
		print "<html><head>\n";
		print "<title>",&html_escape(&decode_mimewords(
			$mail->{'header'}->{'subject'})),"</title></head>\n";
		print "<body bgcolor=#ffffff onLoad='window.print()'>\n";

		# Display the headers
		print "<table width=100% border=1>\n";
		print "<tr $tb> <td><b>$text{'view_headers'}</b></td> </tr>\n";
		print "<tr $cb> <td><table width=100%>\n";
		print "<tr> <td><b>$text{'mail_from'}</b></td> ",
		      "<td>",&eucconv(&html_escape($mail->{'header'}->{'from'})),"</td> </tr>\n";
		print "<tr> <td><b>$text{'mail_to'}</b></td> ",
		      "<td>",&eucconv(&html_escape($mail->{'header'}->{'to'})),"</td> </tr>\n";
		print "<tr> <td><b>$text{'mail_cc'}</b></td> ",
		      "<td>",&eucconv(&html_escape($mail->{'header'}->{'cc'})),"</td> </tr>\n"
			if ($mail->{'header'}->{'cc'});
		print "<tr> <td><b>$text{'mail_date'}</b></td> ",
		      "<td>",&eucconv(&html_escape(&html_escape($mail->{'header'}->{'date'}))),
		      "</td> </tr>\n";
		print "<tr> <td><b>$text{'mail_subject'}</b></td> ",
		      "<td>",&eucconv(&html_escape(&decode_mimewords(
			$mail->{'header'}->{'subject'}))),"</td> </tr>\n";
		print "</table></td></tr></table><p>\n";

		# Just display the mail body for printing
		if ($body eq $textbody) {
			print "<table border width=100%><tr $cb><td><pre>";
			foreach $l (&wrap_lines($body->{'data'},
						$userconfig{'wrap_width'})) {
				print &eucconv(&html_escape($l)),"\n";
				}
			print "</pre></td></tr></table>\n";
			}
		elsif ($body eq $htmlbody) {
			print "<table border width=100%><tr><td>\n";
			print &safe_html($body->{'data'});
			print "</td></tr></table>\n";
			}

		print "</body></html>\n";
		exit;
		}
	elsif ($in{'mark1'} || $in{'mark2'}) {
		# Just mark the message
		dbmopen(%read, "$user_module_config_directory/read", 0600);
		$mode = $in{'mark1'} ? $in{'mode1'} : $in{'mode2'};
		if ($mode) {
			$read{$mail->{'header'}->{'message-id'}} = $mode;
			}
		else {
			delete($read{$mail->{'header'}->{'message-id'}});
			}
		$perpage = $folder->{'perpage'} || $userconfig{'perpage'};
		$s = int((@mails - $in{'idx'} - 1) / $perpage) * $perpage;
		&redirect("index.cgi?start=$s&folder=$in{'folder'}");
		exit;
		}
	elsif ($in{'detach'} && $config{'server_attach'} == 2) {
		# Detach some attachment to a directory on the server
		&error_setup($text{'detach_err'});
		$in{'dir'} || &error($text{'detach_edir'});
		$in{'dir'} = "$remote_user_info[7]/$in{'dir'}"
			if ($in{'dir'} !~ /^\//);
		&decode_and_sub();
		$attach = $mail->{'attach'}->[$in{'attach'}];

		# Work out where to write
		local $path;
		if (-d $in{'dir'}) {
			# Just write to the filename in the directory
			local $fn;
			if ($attach->{'filename'}) {
				$fn = &decode_mimewords($attach->{'filename'});
				}
			else {
				$attach->{'type'} =~ /\/(\S+)$/;
				$fn = "file.$1";
				}
			$path = "$in{'dir'}/$fn";
			}
		else {
			# Assume a full path was given
			$path = $in{'dir'};
			}

		# Try to write the file
		open(FILE, ">$path") ||
			&error(&text('detach_eopen', "<tt>$path</tt>", $!));
		(print FILE $attach->{'data'}) ||
			&error(&text('detach_ewrite', "<tt>$path</tt>", $!));
		close(FILE) ||
			&error(&text('detach_ewrite', "<tt>$path</tt>", $!));

		# Show a message about the new file
		&header($text{'detach_title'}, "");
		print "<hr>\n";

		local $sz = (int(length($attach->{'data'})/1000)+1)." Kb";
		print "<p>",&text('detach_ok', "<tt>$path</tt>", $sz),"<p>\n";

		print "<hr>\n";
		&footer("view_mail.cgi?idx=$in{'idx'}&folder=$in{'folder'}",
			$text{'view_return'},
			"index.cgi?folder=$in{'folder'}", $text{'mail_return'});
		exit;
		}
	elsif ($in{'black'}) {
		# Add sender to SpamAssassin blacklist, and tell user
		&header($text{'black_title'}, "");
		print "<hr>\n";

		&foreign_require("spam", "spam-lib.pl");
		local $conf = &spam::get_config();
		local @from = map { @{$_->{'words'}} }
			    	  &spam::find("blacklist_from", $conf);
		local %already = map { $_, 1 } @from;
		local ($spamfrom) = &address_parts($mail->{'header'}->{'from'});
		if ($already{$spamfrom}) {
			print "<b>",&text('black_already',
					  "<tt>$spamfrom</tt>"),"</b><p>\n";
			}
		else {
			push(@from, $spamfrom);
			&spam::save_directives($conf, 'blacklist_from',
					       \@from, 1);
			&flush_file_lines();
			print "<b>",&text('black_done',
					  "<tt>$spamfrom</tt>"),"</b><p>\n";
			}

		print "<hr>\n";
		&footer("view_mail.cgi?idx=$in{'idx'}&folder=$in{'folder'}",
			$text{'view_return'},
			"index.cgi?folder=$in{'folder'}", $text{'mail_return'});
		exit;
		}
	elsif ($in{'razor'}) {
		# Report message to Razor and tell user
		&header($text{'razor_title'}, "");
		print "<hr>\n";

		print "<p><b>$text{'razor_report'}</b>\n";
		print "<pre>";
		local %sconfig = &foreign_config("spam");
		local $temp = &tempname();
		&send_mail($mail, $temp, 0, 1);
		open(OUT, "$sconfig{'spamassassin'} --report <$temp 2>&1 |");
		local $error;
		while(<OUT>) {
			print &html_escape($_);
			$error++ if (/failed/i);
			}
		close(OUT);
		unlink($temp);
		print "</pre>\n";
		if ($? || $error) {
			print "<b>$text{'razor_err'}</b><p>\n";
			}
		else {
			print "<b>$text{'razor_done'}</b><p>\n";
			}

		print "<hr>\n";
		&footer("view_mail.cgi?idx=$in{'idx'}&folder=$in{'folder'}",
			$text{'view_return'},
			"index.cgi?folder=$in{'folder'}", $text{'mail_return'});
		exit;
		}

	if (!@mailforward) {
		&parse_mail($mail);
		&decrypt_attachments($mail);
		@attach = @{$mail->{'attach'}};
		}

	&header($in{'forward'} || @mailforward ? $text{'forward_title'} :
		$in{'enew'} ? $text{'enew_title'} :
			      $text{'reply_title'}, "");

	if ($in{'enew'}) {
		# Editing an existing message, so keep same fields
		$to = $mail->{'header'}->{'to'};
		$rto = $mail->{'header'}->{'reply-to'};
		$from = $mail->{'header'}->{'from'};
		$cc = $mail->{'header'}->{'cc'};
		$ouser = $1 if ($from =~ /^(\S+)\@/);
		}
	else {
		if (!$in{'forward'} && !@mailforward) {
			# Replying to a message, so set To: field
			$to = $mail->{'header'}->{'reply-to'};
			$to = $mail->{'header'}->{'from'} if (!$to);
			}
		if ($in{'rall'}) {
			# If replying to all, add any addresses in the original
			# To: or Cc: to our new Cc: address.
			# XXX should strip own addresses
			$cc = $mail->{'header'}->{'to'};
			$cc .= ", ".$mail->{'header'}->{'cc'}
				if ($mail->{'header'}->{'cc'});
			}
		}

	# Work out new subject, depending on whether we are replying
	# our forwarding a message (or neither)
	local $qu = !$in{'enew'} &&
		    (!$in{'forward'} || !$userconfig{'fwd_mode'});
	$subject = &html_escape(&decode_mimewords(
				$mail->{'header'}->{'subject'}));
	$subject = "Re: ".$subject if ($subject !~ /^Re/i && !$in{'forward'} &&
				       !@mailforward && !$in{'enew'});
	$subject = "Fwd: ".$subject if ($subject !~ /^Fwd/i &&
					($in{'forward'} || @mailforward));

	# Construct the initial mail text
	local ($plainbody, $htmlbody) = &find_body($mail);
	if ($plainbody) {
		$body = $plainbody;
		$quote = $plainbody->{'data'};
		}
	elsif ($htmlbody) {
		$body = $htmlbody;
		$quote = &html_to_text($htmlbody->{'data'});
		}
	if ($quote && $qu) {
		$quote = join("", map { "> $_\n" } &wrap_lines($quote, 70));
		}
	$quote = &decode_mimewords($mail->{'header'}->{'from'}).
		 " wrote ..\n".$quote if ($quote && $qu);
	$sig = &get_signature();
	$quote .= "\n$sig" if ($sig);
	if ($in{'forward'} || $in{'enew'}) {
		@attach = grep { $_ ne $body } @attach;
		}
	else {
		undef(@attach);
		}
	}
print "<hr>\n";

print "<form action=send_mail.cgi method=post enctype=multipart/form-data>\n";
print "<input type=hidden name=ouser value='$ouser'>\n";
print "<input type=hidden name=idx value='$in{'idx'}'>\n";
print "<input type=hidden name=folder value='$in{'folder'}'>\n";
print "<input type=hidden name=new value='$in{'new'}'>\n";
print "<input type=hidden name=enew value='$in{'enew'}'>\n";
foreach $s (@sub) {
	print "<input type=hidden name=sub value='$s'>\n";
	}

print "<table width=100% border=1>\n";
print "<tr> <td $tb><b>$text{'reply_headers'}</b></td> </tr>\n";
print "<tr> <td $cb><table width=100%>\n";
print "<tr> <td><b>$text{'mail_from'}</b></td>\n";
if ($from) {
	# Got From address
	@froms = ( $from );
	}
else {
	# Work out From: address
	local $http_host = $ENV{'HTTP_HOST'};
	$http_host =~ s/:\d+$//;
	if (&check_ipaddress($http_host)) {
		# Try to reverse-lookup IP
		local $rev = gethostbyaddr(inet_aton($acptip), AF_INET);
		$http_host = $rev if ($rev);
		}
	$http_host =~ s/^(www|ftp|mail)\.//;
	$hostname = $config{'server_name'} eq '*' ? $http_host :
		    $config{'server_name'} eq '' ? &get_system_hostname() :
						   $config{'server_name'};
	@doms = split(/\s+/, $hostname);
	local $ru = $remote_user;
	$ru =~ s/\.\Q$http_host\E$//;
	if ($http_host =~ /^([^\.]+)/) {
		$ru =~ s/\.\Q$1\E//;
		}
	@froms = map { $ru.'@'.$_ } @doms;
	if ($config{'from_map'}) {
		open(MAP, $config{'from_map'});
		while(<MAP>) {
			s/\r|\n//g;
			s/#.*$//;
			if (/^\s*(\S+)\s+(\S+)/ &&
			    ($1 eq $remote_user || &indexof($1, @froms) >= 0)) {
				push(@mfroms, $2);
				}
			}
		close(MAP);
		}
	@froms = @mfroms if (@mfroms > 0);
	$remote_user_info[6] =~ s/,.*$//;
	foreach $f (@froms) {
		$f = "\"$remote_user_info[6]\" <$f>"
			if ($remote_user_info[6] && $userconfig{'real_name'});
		}
	}

@faddrs = grep { $_->[3] } &list_addresses();
($defaddr) = grep { $_->[3] == 2 } @faddrs;
if ($folder->{'fromaddr'}) {
	($defaddr) = &split_addresses($folder->{'fromaddr'});
	}
if ($config{'edit_from'} == 1) {
	# User can enter any from address he wants
	if ($defaddr) {
		# Address book contains a default from address
		$froms[0] = $defaddr->[1] ? "\"$defaddr->[1]\" <$defaddr->[0]>"
					  : $defaddr->[0];
		}
	print "<td><input name=from size=40 value='",
		&html_escape($froms[0]),"'> ",
		@faddrs ? &address_button("from", 0, 1) : "","</td>\n";
	}
elsif ($config{'edit_from'} == 2) {
	# Only the real name and username part is editable
	local ($real, $user, $dom);
	local ($sp) = $defaddr || &split_addresses($froms[0]);
	$real = $sp->[1];
	if ($sp->[0] =~ /^(\S+)\@(\S+)$/) {
		$user = $1; $dom = $2;
		}
	else {
		$user = $sp->[0];
		}
	print "<td><input name=real size=15 value='".&html_escape($real)."'>\n";
	print "&lt;<input name=user size=10 value='$user'>\@";
	if (@doms > 1) {
		print "<select name=dom>\n";
		foreach $d (@doms) {
			print "<option>$d\n";
			}
		print "</select>&gt;\n";
		}
	else {
		print "$dom&gt;\n";
		print "<input type=hidden name=dom value='$dom'>\n";
		}
	print &address_button("user", 0, 2, "real") if (@faddrs);
	print "</td>\n";
	}
else {
	# A fixed From address, or a choice of fixed options
	if (@froms > 1) {
		print "<td><select name=from>\n";
		foreach $f (@froms) {
			printf "<option>%s\n", &html_escape($f);
			}
		print "</select></td>\n";
		}
	else {
		print "<td><tt>",&html_escape($froms[0]),"</tt></td>\n";
		print "<input type=hidden name=from value='",
		      &html_escape($froms[0]),"'></td>\n";
		}
	}
$to = &html_escape($to);
if ($userconfig{'reply_to'} ne 'x') {
	# Show Reply-To: and To: fields
	$rto = &html_escape($userconfig{'reply_to'})
		if ($userconfig{'reply_to'} ne '*');
	print "<td><b>$text{'mail_replyto'}</b></td> ",
	      "<td><input name=replyto size=40 value=\"$rto\"> ",
	      @faddrs ? &address_button("replyto", 0, 1) : "","</td> </tr>\n";

	print "<td><b>$text{'mail_to'}</b></td> ",
	      "<td colspan=3><input name=to size=70 value=\"$to\"> ",
	      &address_button("to"),"</td> </tr>\n";
	}
else {
	# Just show To: field
	print "<td><b>$text{'mail_to'}</b></td> ",
	      "<td><input name=to size=40 value=\"$to\"> ",
	      &address_button("to"),"</td> </tr>\n";
	}
$cc = &html_escape($cc);
print "<tr> <td><b>$text{'mail_cc'}</b></td> ",
      "<td><input name=cc size=40 value=\"$cc\"> ",
      &address_button("cc"),"</td>\n";
print "<td><b>$text{'mail_bcc'}</b></td> ",
      "<td><input name=bcc size=40 value=''> ",
      &address_button("bcc"),"</td> </tr>\n";
print "<tr> <td><b>$text{'mail_subject'}</b></td> ",
      "<td><input name=subject size=40 value=\"$subject\"></td>\n";
print "<td><b>$text{'mail_pri'}</b></td> ",
      "<td><table cellpadding=0 cellspacing=0 width=100%>\n",
      "<tr><td align=left><select name=pri>\n",
      "<option value=1>$text{'mail_highest'}\n",
      "<option value=2>$text{'mail_high'}\n",
      "<option value='' selected>$text{'mail_normal'}\n",
      "<option value=4>$text{'mail_low'}\n",
      "<option value=5>$text{'mail_lowest'}\n",
      "</select></td>\n",
      "<td align=right><input type=submit value=\"$text{'reply_send'}\">\n",
      "&nbsp;&nbsp;",
      "<input type=submit name=draft value=\"$text{'reply_draft'}\"></td>\n",
      "</tr></table></td></tr>\n";
if (&has_command("gpg") && &foreign_check("gnupg")) {
	&foreign_require("gnupg", "gnupg-lib.pl");
	local @keys = &foreign_call("gnupg", "list_keys");
	if (@keys) {
		print "<tr> <td colspan=2><b>$text{'mail_sign'}</b>\n";
		print "<select name=sign>\n";
		print "<option selected value=''>$text{'mail_nosign'}\n";
		foreach $k (@keys) {
			printf "<option value=%d>%s\n",
				$k->{'index'}, &html_escape($k->{'name'}->[0])
					if ($k->{'secret'});
			}
		print "</select></td>\n";

		print "<td colspan=2><b>$text{'mail_crypt'}</b>\n";
		print "<select name=crypt>\n";
		print "<option selected value=''> $text{'mail_nocrypt'}\n";
		print "<option value=-1> $text{'mail_samecrypt'}\n";
		foreach $k (@keys) {
			printf "<option value=%d>%s\n",
				$k->{'index'}, &html_escape($k->{'name'}->[0]);
			}
		print "</select></td> </tr>\n";
		}
	}
print "</table></td></tr></table><p>\n";

print "<table width=100% border=1><tr><td $cb>",
      "<textarea rows=20 cols=80 name=body $config{'wrap_mode'}>",
      &html_escape($quote),"</textarea>\n";
if (&has_command("ispell")) {
	print "<br>\n";
	print "<input type=checkbox name=spell value=1> $text{'reply_spell'}\n";
	}
print "</td></tr></table><p>\n";

# Display forwarded attachments
if (@attach) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $tb><b>$text{'reply_attach'}</b></td> </tr>\n";
	print "<tr> <td $cb>\n";
	foreach $a (@attach) {
		push(@titles, "<input type=checkbox name=forward value=$a->{'idx'} checked> ".($a->{'filename'} ? $a->{'filename'} : $a->{'type'}));
		push(@links, "detach.cgi?idx=$in{'idx'}&folder=$in{'folder'}&attach=$a->{'idx'}$subs");
		push(@icons, "images/boxes.gif");
		}
	&icons_table(\@links, \@titles, \@icons, 8);
	print "</td></tr></table><p>\n";
	}

# Display forwarded mails
if (@mailforward) {
	print "<table width=100% border=1>\n";
	print "<tr> <td $tb><b>$text{'reply_mailforward'}</b></td> </tr>\n";
	print "<tr> <td $cb>\n";
	foreach $f (@mailforward) {
		push(@titles, &simplify_subject($mails[$f]->{'header'}->{'subject'}));
		push(@links, "view_mail.cgi?idx=$f&folder=$in{'folder'}");
		push(@icons, "images/boxes.gif");
		print "<input type=hidden name=mailforward value=$f>\n";
		}
	&icons_table(\@links, \@titles, \@icons, 8);
	print "</td></tr></table><p>\n";
	}

# Add form for more attachments
print "<table width=100% border=1>\n";
print "<tr $tb> <td colspan=3><b>$text{'reply_attach2'}</b></td> </tr>\n";

print "<tr $cb> <td><input type=file size=20 name=attach0></td>\n";
print "<td><input type=file size=20 name=attach1></td>\n";
print "<td><input type=file size=20 name=attach2></td> </tr>\n";

print "<tr $cb> <td><input type=file size=20 name=attach3></td>\n";
print "<td><input type=file size=20 name=attach4></td>\n";
print "<td><input type=file size=20 name=attach5></td> </tr>\n";

if ($config{'server_attach'}) {
	print "<tr $cb> <td><input name=file0 size=20> ",
		&file_chooser_button("file0"),"</td>\n";
	print "<td><input name=file1 size=20> ",
		&file_chooser_button("file1"),"</td>\n";
	print "<td><input name=file2 size=20> ",
		&file_chooser_button("file2"),"</td> </tr>\n";
	}

print "</table><p>\n";
print "<input type=submit value=\"$text{'reply_send'}\">&nbsp;&nbsp;\n";
print "<input type=submit name=draft value=\"$text{'reply_draft'}\">\n";
print "</form>\n";

print "<hr>\n";
&footer("index.cgi?folder=$in{'folder'}", $text{'mail_return'});
&pop3_logout_all();

sub decode_and_sub
{
&notes_decode($mail, $folder);
&parse_mail($mail);
@sub = split(/\0/, $in{'sub'});
$subs = join("", map { "&sub=$_" } @sub);
foreach $s (@sub) {
	# We are looking at a mail within a mail ..
	&decrypt_attachments($mail);
	local $amail = &extract_mail(
			$mail->{'attach'}->[$s]->{'data'});
	&parse_mail($amail);
	$mail = $amail;
	}
($deccode, $decmessage) = &decrypt_attachments($mail);
}

